> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tirdad.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Query an analytics view

> Resolves the view's definition against the supplied variables and executes it.



## OpenAPI

````yaml /api-reference/openapi.json post /analytics/views/{id}/query
openapi: 3.0.1
info:
  title: Tirdad API
  description: Tirdad API Service
  contact:
    name: API Support
  version: '1.0'
servers:
  - url: https://api.tirdad.ai/v1
    description: Tirdad API
security: []
paths:
  /analytics/views/{id}/query:
    post:
      tags:
        - Analytics
      summary: Query an analytics view
      description: >-
        Resolves the view's definition against the supplied variables and
        executes it.
      operationId: queryAnalyticsView
      parameters:
        - name: id
          in: path
          description: View ID
          required: true
          schema:
            type: string
      requestBody:
        description: View query request
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ViewQueryRequest'
        required: true
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AnalyticsQueryResult'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/errors.ErrorResponse'
        '404':
          description: View not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/errors.ErrorResponse'
        '500':
          description: Server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/errors.ErrorResponse'
      security:
        - ApiKeyAuth: []
      x-codeSamples:
        - lang: go
          label: Go
          source: "package main\n\nimport(\n\t\"context\"\n\ttirdad \"github.com/tirdad-billing/go-sdk/v2\"\n\t\"github.com/tirdad-billing/go-sdk/v2/models/types\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := tirdad.New(\n        tirdad.WithSecurity(\"<YOUR_API_KEY_HERE>\"),\n    )\n\n    res, err := s.Analytics.QueryAnalyticsView(ctx, \"<id>\", types.ViewQueryRequest{})\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.AnalyticsQueryResult != nil {\n        // handle response\n    }\n}"
        - lang: python
          label: Python
          source: |-
            from tirdad_sdk import Tirdad


            with Tirdad(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as f_client:

                res = f_client.analytics.query_analytics_view(id="<id>")

                # Handle response
                print(res)
        - lang: typescript
          label: TypeScript
          source: |-
            import { Tirdad } from "@tirdad/sdk";

            const tirdad = new Tirdad({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await tirdad.analytics.queryAnalyticsView("<id>", {});

              console.log(result);
            }

            run();
components:
  schemas:
    ViewQueryRequest:
      type: object
      properties:
        variables:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
    AnalyticsQueryResult:
      type: object
      properties:
        columns:
          type: array
          items:
            $ref: '#/components/schemas/AnalyticsColumn'
        meta:
          $ref: '#/components/schemas/AnalyticsQueryMeta'
        rows:
          type: array
          items:
            type: array
            items:
              type: string
    errors.ErrorResponse:
      type: object
      properties:
        code:
          $ref: '#/components/schemas/errors.ErrorCode'
        http_status_code:
          type: integer
        message:
          type: string
      x-speakeasy-name-override: ErrorResponse
    AnalyticsColumn:
      type: object
      properties:
        currency:
          type: string
        name:
          type: string
        role:
          $ref: '#/components/schemas/types.ColumnRole'
        type:
          $ref: '#/components/schemas/types.ColumnType'
    AnalyticsQueryMeta:
      type: object
      properties:
        from:
          type: string
        prev_from:
          type: string
        prev_to:
          type: string
        query_source:
          type: string
        to:
          type: string
    errors.ErrorCode:
      type: string
      enum:
        - http_client_error
        - system_error
        - internal_error
        - not_found
        - already_exists
        - version_conflict
        - validation_error
        - invalid_operation
        - permission_denied
        - database_error
        - service_unavailable
        - too_many_requests
        - not_implemented
      x-enum-varnames:
        - ErrCodeHTTPClient
        - ErrCodeSystemError
        - ErrCodeInternalError
        - ErrCodeNotFound
        - ErrCodeAlreadyExists
        - ErrCodeVersionConflict
        - ErrCodeValidation
        - ErrCodeInvalidOperation
        - ErrCodePermissionDenied
        - ErrCodeDatabase
        - ErrCodeServiceUnavailable
        - ErrCodeTooManyRequests
        - ErrCodeNotImplemented
      x-speakeasy-name-override: ErrorCode
    types.ColumnRole:
      type: string
      enum:
        - dimension
        - metric
      x-enum-varnames:
        - ColumnRoleDimension
        - ColumnRoleMetric
      x-speakeasy-name-override: ColumnRole
    types.ColumnType:
      type: string
      enum:
        - string
        - decimal
        - datetime
      x-enum-varnames:
        - ColumnTypeString
        - ColumnTypeDecimal
        - ColumnTypeDatetime
      x-speakeasy-name-override: ColumnType
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      description: Enter your API key in the format *x-api-key &lt;api-key&gt;**
      name: x-api-key
      in: header

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.